#include "maths.hpp"
#include <vector>

namespace icfp {

    class link;

    class obstacle {
        public:
            obstacle( std::istream & );

            icfp::position position;
            double radius;
    };
    
    class map {
        public:
            map();

        float width, height;
        std::vector< icfp::obstacle > obstacles;
    };

    
    class rover {
        public:
            rover();

        void move( const link &, map & );
        
        char accelerator, steering;
        icfp::position position, waypoint;
        float dir, speed;
    };

    
}

