#include "maths.hpp"
#include <cmath>

namespace {
    double todegrees( double radians ) {
        return radians * 180 / icfp::pi;
    }
}

double icfp::bearing( position from, position to ) {
    return todegrees( std::atan2( to.second - from.second, to.first - from.first ) );
}


int icfp::relative_bearing( double rover, double target ) {
    return int( rover - target + 900 ) % 360 - 180;
}


bool icfp::will_collide( icfp::position location, double direction, icfp::position with, double radius ) {
    int rb = icfp::relative_bearing( direction, icfp::bearing( location, with ) );
    return rb > -3 && rb < 3;
}
